// Auto-generated. Do not edit!

// (in-package jsk_footstep_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let FootstepArray = require('./FootstepArray.js');

//-----------------------------------------------------------

class PlanFootstepsGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.goal_footstep = null;
      this.initial_footstep = null;
      this.timeout = null;
    }
    else {
      if (initObj.hasOwnProperty('goal_footstep')) {
        this.goal_footstep = initObj.goal_footstep
      }
      else {
        this.goal_footstep = new FootstepArray();
      }
      if (initObj.hasOwnProperty('initial_footstep')) {
        this.initial_footstep = initObj.initial_footstep
      }
      else {
        this.initial_footstep = new FootstepArray();
      }
      if (initObj.hasOwnProperty('timeout')) {
        this.timeout = initObj.timeout
      }
      else {
        this.timeout = {secs: 0, nsecs: 0};
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PlanFootstepsGoal
    // Serialize message field [goal_footstep]
    bufferOffset = FootstepArray.serialize(obj.goal_footstep, buffer, bufferOffset);
    // Serialize message field [initial_footstep]
    bufferOffset = FootstepArray.serialize(obj.initial_footstep, buffer, bufferOffset);
    // Serialize message field [timeout]
    bufferOffset = _serializer.duration(obj.timeout, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PlanFootstepsGoal
    let len;
    let data = new PlanFootstepsGoal(null);
    // Deserialize message field [goal_footstep]
    data.goal_footstep = FootstepArray.deserialize(buffer, bufferOffset);
    // Deserialize message field [initial_footstep]
    data.initial_footstep = FootstepArray.deserialize(buffer, bufferOffset);
    // Deserialize message field [timeout]
    data.timeout = _deserializer.duration(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += FootstepArray.getMessageSize(object.goal_footstep);
    length += FootstepArray.getMessageSize(object.initial_footstep);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'jsk_footstep_msgs/PlanFootstepsGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '68011023a311776030c53b8ca437fae1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # goal
    FootstepArray goal_footstep
    FootstepArray initial_footstep
    duration timeout
    
    ================================================================================
    MSG: jsk_footstep_msgs/FootstepArray
    Header header
    Footstep[] footsteps
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: jsk_footstep_msgs/Footstep
    uint8 RIGHT=2
    uint8 LEFT=1
    
    # Constants to visualize progress
    uint8 REJECTED=3
    uint8 APPROVED=4
    
    ## limb_indicator values
    uint8 LLEG=1
    uint8 RLEG=2
    uint8 LARM=5
    uint8 RARM=6
    
    uint8 leg ## value should be one of limb_indicator values.
    geometry_msgs/Pose pose ## 'pose' represents nominal pose. It may be an end-effector of limb.
    duration duration
    # optional parameters
    uint32 footstep_group
    geometry_msgs/Vector3 dimensions ## cube [length(x), width(y), height(z)]
    geometry_msgs/Vector3 offset     ## offset from pose to center of cube
    float32 swing_height
    float32 cost
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PlanFootstepsGoal(null);
    if (msg.goal_footstep !== undefined) {
      resolved.goal_footstep = FootstepArray.Resolve(msg.goal_footstep)
    }
    else {
      resolved.goal_footstep = new FootstepArray()
    }

    if (msg.initial_footstep !== undefined) {
      resolved.initial_footstep = FootstepArray.Resolve(msg.initial_footstep)
    }
    else {
      resolved.initial_footstep = new FootstepArray()
    }

    if (msg.timeout !== undefined) {
      resolved.timeout = msg.timeout;
    }
    else {
      resolved.timeout = {secs: 0, nsecs: 0}
    }

    return resolved;
    }
};

module.exports = PlanFootstepsGoal;
